package infoh509.tp3.jdom.ex1;

import java.io.File;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import org.jdom.Document;
import org.jdom.Element;
import org.jdom.JDOMException;
import org.jdom.input.SAXBuilder;
import org.jdom.xpath.XPath;

public class Exercice5 {
	private Map<String, Set<String>> countriesCustomers = new HashMap<String, Set<String>>();
	
	private void putCountryCustomer(String country, String customer) {
		/* initialize the hash map */
		if (!countriesCustomers.containsKey(country)) {
			countriesCustomers.put(country, new HashSet<String>());
		}
		
		/* Add the customer to the country */
		countriesCustomers.get(country).add(customer);
	}
	
	private void run(Document d) throws JDOMException {
		XPath customerCountries = XPath.newInstance("/Root/Customers/Customer/FullAddress/Country");
		XPath ordersCountries = XPath.newInstance("/Root/Orders/Order/ShipInfo/ShipCountry");

		for (Object orderCountry: ordersCountries.selectNodes(d)) {
			String country = ((Element)orderCountry).getText().trim();
			String customer = ((Element)orderCountry).
				getParentElement().getParentElement().getChildText("CustomerID");
			
			putCountryCustomer(country, customer);
		}
		
		for (Object custCountry: customerCountries.selectNodes(d)) {
			String country = ((Element)custCountry).getText().trim();
			String customer = ((Element)custCountry).
				getParentElement().getParentElement().getAttributeValue("CustomerID");
			
			putCountryCustomer(country, customer);
		}		
	}
	
	public static void main(String[] args) {
		
		
		try {
			SAXBuilder b = new SAXBuilder();
			Document d = b.build(new File("data/orders.xml"));
			Exercice5 ex = new Exercice5();
			
			ex.run(d);
			
			/* Print countries and customers */
			for (String country: ex.countriesCustomers.keySet()) {
				System.out.println(country);
				
				for (String customer: ex.countriesCustomers.get(country)) {
					System.out.println("\t" + customer);
				}
			}
		} 
		catch (Exception e) { 
			e.printStackTrace(); 
		}
	}
}
