package infoh509.tp3.sax.ex1;

import org.xml.sax.Attributes;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.helpers.XMLReaderFactory;

public class Exercice2 extends DefaultHandler {
	private boolean displayName = false;
	private boolean displayPhone = false;

	public void startElement(String uri, String localName,
			String qName, Attributes atts) {

		/* On veut garder les contacts et leurs numero de telephone */
		if (localName.equals("ContactName")) {
			displayName = true;
		}
		else if (localName.equals("Phone")) {
			displayPhone = true;
		}
	}

	public void endElement(String uri, String localName, 
			String qName) {
		
		/* Fin de l'element, on ne veut plus garder le contenu */
		if (localName.equals("ContactName")) {
			displayName = false;
		}
		else if (localName.equals("Phone")) {
			displayPhone = false;
		}
	}

	public void characters(char[] ch, int start, int length) {
		String text = new String(ch,start,length);

		/* Si on s'interesse au contenu de l'element, on l'affiche */
		if (displayName) {
			System.out.println(text);
		}
		else if (displayPhone) {
			System.out.println("\t" + text);
		}
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		XMLReader reader;
		try {
			/* Read the file passed as parameter using SAX */
			reader = XMLReaderFactory.createXMLReader();
			reader.setContentHandler(new Exercice2());
			reader.parse("data/orders.xml");
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
