package infoh509.tp3.sax.ex1;

import org.xml.sax.Attributes;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.helpers.XMLReaderFactory;

public class Exercice4 extends DefaultHandler {
	private boolean valid = true;
	private boolean freight = false;
	
	public void startElement(String uri, String localName,
			String qName, Attributes atts) {

		/* On veut les pays de livraison */
		if (localName.equals("Freight")) {
			freight = true;
		}
	}

	public void endElement(String uri, String localName, 
			String qName) {
		
		/* Fin de l'element, on ne veut plus garder le contenu */
		if (localName.equals("Freight")) {
			freight = false;
		}
	}

	public void characters(char[] ch, int start, int length) {
		String text = new String(ch,start,length);

		if (freight) {
			if (Double.parseDouble(text) < 2) {
				valid = false;
			}
		}
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		XMLReader reader;
		try {
			Exercice4 myHandler = new Exercice4();
			
			/* Read the file passed as parameter using SAX */
			reader = XMLReaderFactory.createXMLReader();
			reader.setContentHandler(myHandler);
			reader.parse("data/orders.xml");
			
			if (myHandler.valid) {
				System.out.println("OK");
			}
			else {
				System.out.println("PAS OK");
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
